diff --git a/doc/src/sgml/filelist.sgml b/doc/src/sgml/filelist.sgml
index 68179f71cd..ca29c8bc4e 100644
--- a/doc/src/sgml/filelist.sgml
+++ b/doc/src/sgml/filelist.sgml
@@ -8,9 +8,10 @@
 <!ENTITY problems   SYSTEM "problems.sgml">
 
 <!-- tutorial -->
-<!ENTITY advanced   SYSTEM "advanced.sgml">
-<!ENTITY query      SYSTEM "query.sgml">
-<!ENTITY start      SYSTEM "start.sgml">
+<!ENTITY start         SYSTEM "start.sgml">
+<!ENTITY architecture  SYSTEM "architecture.sgml">
+<!ENTITY query         SYSTEM "query.sgml">
+<!ENTITY advanced      SYSTEM "advanced.sgml">
 
 <!-- user's guide -->
 <!ENTITY array      SYSTEM "array.sgml">
diff --git a/doc/src/sgml/glossary.sgml b/doc/src/sgml/glossary.sgml
index 8c6cb6e942..ff2355a10c 100644
--- a/doc/src/sgml/glossary.sgml
+++ b/doc/src/sgml/glossary.sgml
@@ -141,7 +141,8 @@
    <glossterm>Background Writer (process)</glossterm>
    <glossdef>
     <para>
-     A process that continuously writes dirty pages from
+     A process that continuously writes
+     <glossterm linkend="glossary-dirty-buffer">dirty buffers</glossterm> from
      <glossterm linkend="glossary-shared-memory">shared memory</glossterm> to
      the file system.  It wakes up periodically, but works only for a short
      period in order to distribute its expensive <acronym>I/O</acronym>
@@ -155,6 +156,16 @@
    </glossdef>
   </glossentry>
 
+  <glossentry id="glossary-bloat">
+   <glossterm>Bloat</glossterm>
+   <glossdef>
+    <para>
+     Bloat is disk or RAM space, which does not contain relevant
+     data, e.g.: free space within blocks or outdated row versions.
+    </para>
+   </glossdef>
+  </glossentry>
+
   <glossentry id="glossary-cast">
    <glossterm>Cast</glossterm>
    <glossdef>
@@ -208,15 +219,6 @@
    </glossdef>
   </glossentry>
 
-  <glossentry id="glossary-checkpointer">
-   <glossterm>Checkpointer (process)</glossterm>
-   <glossdef>
-    <para>
-     A specialized process responsible for executing checkpoints.
-    </para>
-   </glossdef>
-  </glossentry>
-
   <glossentry id="glossary-checkpoint">
    <glossterm>Checkpoint</glossterm>
    <glossdef>
@@ -244,6 +246,15 @@
    </glossdef>
   </glossentry>
 
+  <glossentry id="glossary-checkpointer">
+   <glossterm>Checkpointer (process)</glossterm>
+   <glossdef>
+    <para>
+     A specialized process responsible for executing checkpoints.
+    </para>
+   </glossdef>
+  </glossentry>
+
   <glossentry>
    <glossterm>Class (archaic)</glossterm>
    <glosssee otherterm="glossary-relation" />
@@ -446,6 +457,26 @@
    </glossdef>
   </glossentry>
 
+  <glossentry id="glossary-dirty-buffer">
+   <glossterm>Dirty Buffer</glossterm>
+   <glossdef>
+    <para>
+     File pages are mirrored in RAM (<glossterm
+     linkend="glossary-shared-memory">Shared Memory</glossterm>).
+     Data changes happens in a first step in RAM and are
+     transfered to disk at a later point in time. During the period
+     from the buffer change to its tranfer to disk, he is
+     called a dirty buffer. Sometimes people use the term
+     <glossterm linkend="glossary-dirty-page">dirty page</glossterm>.
+    </para>
+   </glossdef>
+  </glossentry>
+
+  <glossentry id="glossary-dirty-page">
+   <glossterm>Dirty Page</glossterm>
+   <glosssee otherterm="glossary-dirty-buffer" />
+  </glossentry>
+
   <glossentry id="glossary-durability">
    <glossterm>Durability</glossterm>
    <glossdef>
@@ -459,6 +490,23 @@
    </glossdef>
   </glossentry>
 
+  <glossentry id="glossary-epoch">
+   <glossterm>Epoch</glossterm>
+   <glossdef>
+    <para>
+     In a time-related context: The number of seconds since
+     00:00:00 UTC on 1 January 1970, minus leap seconds.
+    </para>
+    <para>
+     In reference to transaction IDs: The number of available
+     <glossterm linkend="glossary-xid">xids</glossterm> is limited
+     because they use a 32-bit integer. Sooner or later the
+     sequence must restart from the beginning. Every such roundtrip
+     is called an epoch.
+    </para>
+   </glossdef>
+  </glossentry>
+
   <glossentry id="glossary-extension">
    <glossterm>Extension</glossterm>
    <glossdef>
@@ -564,6 +612,38 @@
    </glossdef>
   </glossentry>
 
+  <glossentry id="glossary-fork">
+   <glossterm>Fork</glossterm>
+   <glossdef>
+    <para>
+     Each table and index has three so-called forks to
+     store data, Free Space Map, and Visibility Map in
+     separate files. The forks are called
+     <literal>'main'</literal>, <literal>'fsm'</literal>,
+     and <literal>'vm'</literal>. An unlogged table has
+     the additional fork <literal>'init'</literal> to
+     initialize the table in case of a crash.
+    </para>
+   </glossdef>
+  </glossentry>
+
+  <glossentry id="glossary-free-space-map">
+   <glossterm>Free Space Map</glossterm>
+   <glossdef>
+    <para>
+     For each table and index exists an assigned file, the
+     Free Space Map. It tracks the amount of free space
+     per page. It is organized as a highly condensed b-tree
+     of (rounded) size.
+    </para>
+
+    <para>
+     For more information, see
+     <xref linkend="storage-fsm"/>.
+    </para>
+   </glossdef>
+  </glossentry>
+
   <glossentry id="glossary-function">
    <glossterm>Function</glossterm>
    <glossdef>
@@ -761,25 +841,6 @@
    </glossdef>
   </glossentry>
 
-  <glossentry id="glossary-logger">
-   <glossterm>Logger (process)</glossterm>
-   <glossdef>
-    <para>
-     If activated, the
-     <glossterm linkend="glossary-logger">Logger</glossterm> process
-     writes information about database events into the current
-     <glossterm linkend="glossary-log-file">log file</glossterm>.
-     When reaching certain time- or
-     volume-dependent criteria, a new log file is created.
-     Also called <firstterm>syslogger</firstterm>.
-    </para>
-    <para>
-     For more information, see
-     <xref linkend="runtime-config-logging"/>.
-    </para>
-   </glossdef>
-  </glossentry>
-
   <glossentry id="glossary-log-record">
    <glossterm>Log Record</glossterm>
     <glossdef>
@@ -803,6 +864,25 @@
    </glossdef>
   </glossentry>
 
+  <glossentry id="glossary-logger">
+   <glossterm>Logger (process)</glossterm>
+   <glossdef>
+    <para>
+     If activated, the
+     <glossterm linkend="glossary-logger">Logger</glossterm> process
+     writes information about database events into the current
+     <glossterm linkend="glossary-log-file">log file</glossterm>.
+     When reaching certain time- or
+     volume-dependent criteria, a new log file is created.
+     Also called <firstterm>syslogger</firstterm>.
+    </para>
+    <para>
+     For more information, see
+     <xref linkend="runtime-config-logging"/>.
+    </para>
+   </glossdef>
+  </glossentry>
+
   <glossentry>
    <glossterm>Master (server)</glossterm>
    <glosssee otherterm="glossary-primary-server" />
@@ -929,8 +1009,8 @@
    </glossdef>
   </glossentry>
 
-  <glossentry id="glossary-postmaster">
-   <glossterm>Postmaster (process)</glossterm>
+  <glossentry id="glossary-postgres">
+   <glossterm>Postgres (process)</glossterm>
    <glossdef>
     <para>
       The very first process of an <glossterm linkend="glossary-instance">instance</glossterm>.
@@ -945,6 +1025,16 @@
    </glossdef>
   </glossentry>
 
+  <glossentry id="glossary-postmaster">
+   <glossterm>Postmaster (process)</glossterm>
+   <glossdef>
+    <para>
+      An outdated term for the <glossterm
+      linkend="glossary-postgres"> Postgres</glossterm> process.
+    </para>
+   </glossdef>
+  </glossentry>
+
   <glossentry id="glossary-primary-server">
    <glossterm>Primary (server)</glossterm>
    <glossdef>
@@ -1188,11 +1278,13 @@
     <para>
      A schema is a namespace for <glossterm linkend="glossary-sql-object">SQL objects</glossterm>,
      which all reside in the same
-     <glossterm linkend="glossary-database">database</glossterm>.  Each
+     <glossterm linkend="glossary-database">database</glossterm>. Each
      SQL object must reside in exactly one schema.
     </para>
     <para>
-     The names of SQL objects of the same type in the same schema are enforced unique.
+     The names of SQL objects in the same schema are enforced unique.
+     This applies across all object types with a single exception:
+     Unique constraints and the according unique index use the same name.
      There is no restriction on reusing a name in multiple schemas.
     </para>
     <para>
@@ -1651,6 +1743,24 @@
    </glossdef>
   </glossentry>
 
+  <glossentry id="glossary-visibility-map">
+   <glossterm>Visiblility Map</glossterm>
+   <glossdef>
+    <para>
+     For each table exists an assigned file, the Visibliltiy Map,
+     which contains two bit per file page. If the first bit
+     is set, it indicates that the associated page does not
+     contain any bloat. If the second one is set, it indicates
+     that the page contains only frozen rows.
+    </para>
+   </glossdef>
+  </glossentry>
+
+  <glossentry>
+   <glossterm>WAL</glossterm>
+   <glosssee otherterm="glossary-wal" />
+  </glossentry>
+
   <glossentry id="glossary-wal-archiver">
    <glossterm>WAL Archiver (process)</glossterm>
    <glossdef>
@@ -1696,11 +1806,6 @@
    </glossdef>
   </glossentry>
 
-  <glossentry>
-   <glossterm>WAL</glossterm>
-   <glosssee otherterm="glossary-wal" />
-  </glossentry>
-
   <glossentry id="glossary-wal-record">
    <glossterm>WAL Record</glossterm>
    <glossdef>
@@ -1728,8 +1833,8 @@
   <glossdef>
    <para>
     A process that writes <glossterm linkend="glossary-wal-record">WAL records</glossterm>
-    from <glossterm id="linkend-shared-memory">shared memory</glossterm> to
-    <glossterm id="linkend-wal-file">WAL files</glossterm>.
+    from <glossterm linkend="glossary-shared-memory">shared memory</glossterm> to
+    <glossterm linkend="glossary-wal-file">WAL files</glossterm>.
    </para>
    <para>
     For more information, see
@@ -1771,5 +1876,45 @@
     </para>
    </glossdef>
   </glossentry>
+
+  <glossentry id="glossary-xid">
+   <glossterm>Transaction ID (xid)</glossterm>
+   <glossdef>
+    <para>
+     Like other objects, transactions need to have an unique
+     ID to identify them. The transaction manager creates
+     the sequence of xids. Because xids are stored in a 32-bit
+     integer, the available range is limited. Sooner or later
+     the sequence of xids must restart from the beginning.
+    </para>
+    <para>
+     There are three special xids:
+    </para>
+     <itemizedlist spacing="compact" mark="none">
+      <listitem>
+       <simpara>
+        <literal>0 (InvalidTransactionId)</literal>: is used for
+        xids of relations which are not a table.
+       </simpara>
+      </listitem>
+      <listitem>
+       <simpara>
+        <literal>1 (BootstrapTransactionId)</literal>: represents
+        transactions used during the first phase of cluster
+        initialization, see: <xref linkend="app-initdb"/>
+       </simpara>
+      </listitem>
+      <listitem>
+       <simpara>
+        <literal>2 (FrozenTransactionId)</literal>: indicates a
+        frozen transaction. This value is no longer used. Instead,
+        the system uses a flag in the header of each row version
+        to mark them as frozen.
+       </simpara>
+      </listitem>
+     </itemizedlist>
+   </glossdef>
+  </glossentry>
+
  </glosslist>
 </appendix>
diff --git a/doc/src/sgml/postgres.sgml b/doc/src/sgml/postgres.sgml
index c41ce9499b..6254bf9376 100644
--- a/doc/src/sgml/postgres.sgml
+++ b/doc/src/sgml/postgres.sgml
@@ -60,6 +60,7 @@ break is not needed in a wider output rendering.
   </partintro>
 
   &start;
+  &architecture;
   &query;
   &advanced;
 
diff --git a/doc/src/sgml/query.sgml b/doc/src/sgml/query.sgml
index c0889743c4..870349780f 100644
--- a/doc/src/sgml/query.sgml
+++ b/doc/src/sgml/query.sgml
@@ -1,7 +1,7 @@
 <!-- doc/src/sgml/query.sgml -->
 
  <chapter id="tutorial-sql">
-  <title>The <acronym>SQL</acronym> Language</title>
+  <title>Basics of the <acronym>SQL</acronym> Language</title>
 
   <sect1 id="tutorial-sql-intro">
    <title>Introduction</title>
diff --git a/doc/src/sgml/start.sgml b/doc/src/sgml/start.sgml
index 5b73557835..b9184feb39 100644
--- a/doc/src/sgml/start.sgml
+++ b/doc/src/sgml/start.sgml
@@ -53,7 +53,7 @@
 
 
   <sect1 id="tutorial-arch">
-   <title>Architectural Fundamentals</title>
+   <title>Client/Server Model</title>
 
    <para>
     Before we proceed, you should understand the basic
@@ -65,37 +65,59 @@
 
    <para>
     In database jargon, <productname>PostgreSQL</productname> uses a
-    client/server model.  A <productname>PostgreSQL</productname>
+    client/server model. A <productname>PostgreSQL</productname>
     session consists of the following cooperating processes
     (programs):
+   </para>
 
-    <itemizedlist>
-     <listitem>
-      <para>
-       A server process, which manages the database files, accepts
-       connections to the database from client applications, and
-       performs database actions on behalf of the clients.  The
-       database server program is called
-       <filename>postgres</filename>.
-       <indexterm><primary>postgres</primary></indexterm>
-      </para>
-     </listitem>
+   <itemizedlist>
+    <listitem>
+     <para>
+      A process at the server site with the name
+      <glossterm linkend="glossary-postmaster">
+      postgres (outdated term: Postmaster)</glossterm>
+      <indexterm><primary>postgres</primary></indexterm>.
+      It accepts connection requests from client applications, starts
+      (<quote>forks</quote>) a new <glossterm linkend="glossary-backend">
+      Backend process</glossterm> for each of them, and passes
+      the connection to it. From that point on, the client and the new
+      <firstterm>Backend process</firstterm>
+      communicate directly without intervention by the original
+      <firstterm>postgres</firstterm> process. Thus, the
+      <firstterm>postgres</firstterm> process is always running, waiting
+      for new client connections, whereas clients and associated
+      <firstterm>Backend processes</firstterm> come and go.
+      (All of this is of course invisible to the user. We only mention it
+      here for completeness.)
+     </para>
+    </listitem>
 
-     <listitem>
-      <para>
-       The user's client (frontend) application that wants to perform
-       database operations.  Client applications can be very diverse
-       in nature:  a client could be a text-oriented tool, a graphical
-       application, a web server that accesses the database to
-       display web pages, or a specialized database maintenance tool.
-       Some client applications are supplied with the
-       <productname>PostgreSQL</productname> distribution; most are
-       developed by users.
-      </para>
-     </listitem>
+    <listitem>
+     <para>
+      A group of processes at the server site, the <glossterm
+      linkend="glossary-instance">instance</glossterm>, to which also the
+      <firstterm>postgres</firstterm> process belongs. Their duties are
+      handling of central, common database activities like file access,
+      vacuum, <glossterm linkend="glossary-checkpoint">checkpoints</glossterm>,
+      replication, and more. The mentioned <firstterm>Backend processes</firstterm>
+      delegate those actions to the <firstterm>instance</firstterm>.
+     </para>
+    </listitem>
 
-    </itemizedlist>
-   </para>
+    <listitem>
+     <para>
+      The user's client (frontend) application that wants to perform
+      database operations.  Client applications can be very diverse
+      in nature:  a client could be a text-oriented tool, a graphical
+      application, a web server that accesses the database to
+      display web pages, or a specialized database maintenance tool.
+      Some client applications are supplied with the
+      <productname>PostgreSQL</productname> distribution; most are
+      developed by users.
+     </para>
+    </listitem>
+
+   </itemizedlist>
 
    <para>
     As is typical of client/server applications, the client and the
@@ -106,18 +128,6 @@
     file name) on the database server machine.
    </para>
 
-   <para>
-    The <productname>PostgreSQL</productname> server can handle
-    multiple concurrent connections from clients.  To achieve this it
-    starts (<quote>forks</quote>) a new process for each connection.
-    From that point on, the client and the new server process
-    communicate without intervention by the original
-    <filename>postgres</filename> process.  Thus, the
-    master server process is always running, waiting for
-    client connections, whereas client and associated server processes
-    come and go.  (All of this is of course invisible to the user.  We
-    only mention it here for completeness.)
-   </para>
   </sect1>
 
 
